//=================================================================================//
//
// UNITED BOT - FRAME WORK
//
// 
// This work is based off several pieces of code by several authors. In no specific
// order:
// 
// Jeffrey "botman" Broome
// Cheeseh
// Stefan Hendriks
// 
//
//=================================================================================//

#include <stdio.h>

// HACK HACK HACK : BASEENTITY ACCESS
#include "cbase.h"
#include "baseentity.h"
// HACK HACK HACK : BASEENTITY ACCESS

#include "interface.h"
#include "filesystem.h"
#include "engine/iserverplugin.h"
#include "dlls/iplayerinfo.h"
#include "eiface.h"
#include "igameevents.h"
#include "IEffects.h"

#include "usercmd.h"
#include "bitbuf.h"

#include "ubbot.h"

// memdbgon must be the last include file in a .cpp file!!!
#include "tier0/memdbgon.h"

///////////////////////////////////////////////////////////////////////////////
// Function : WriteUsercmd()
// Arguments: 2
// Usage    : Writes specific user cmd in delta compressed format into *buf
// Author   : Jeffrey "botman" Broome
// Errormsg : NO
///////////////////////////////////////////////////////////////////////////////
void WriteUsercmd( bf_write *buf, CUserCmd *cmd )
{
	buf->WriteOneBit( 0 );  // command_number

	buf->WriteOneBit( 0 );  // tick_count
    
    // Viewangles (Stefan, thanks to Botman for his reference)
    buf->WriteOneBit( 1 );
    buf->WriteBitAngle( cmd->viewangles[ 0 ], 16 );
    buf->WriteOneBit( 1 );
    buf->WriteBitAngle( cmd->viewangles[ 1 ], 16 );
    buf->WriteOneBit( 1 );
    buf->WriteBitAngle( cmd->viewangles[ 2 ], 8 ); 


	buf->WriteOneBit( 1 );
	buf->WriteSBitLong( cmd->forwardmove, 16 );

	buf->WriteOneBit( 1 );
	buf->WriteSBitLong( cmd->sidemove, 16 );

	buf->WriteOneBit( 1 );
	buf->WriteSBitLong( cmd->upmove, 16 );

	buf->WriteOneBit( 1 );
  	buf->WriteUBitLong( cmd->buttons, 32 );

	buf->WriteOneBit( 1 );
    buf->WriteUBitLong( cmd->impulse, 8 );

	buf->WriteOneBit( 1 );
	buf->WriteUBitLong( cmd->weaponselect, MAX_EDICT_BITS );

	buf->WriteOneBit( 0 );  // weaponsubtype

    // Stefan -> View angles with mouse X and Y...
	// Write mousedX and mousedY (FIX)
	buf->WriteOneBit( 1 );
	buf->WriteShort( cmd->mousedx );
	
	buf->WriteOneBit( 1 );
	buf->WriteShort( cmd->mousedy );
}
