//=================================================================================//
//
// UNITED BOT - FRAME WORK
//
// 
// This work is based off several pieces of code by several authors. In no specific
// order:
// 
// Jeffrey "botman" Broome
// Cheeseh
// Stefan Hendriks
// 
//
//=================================================================================//

#include <stdio.h>

// HACK HACK HACK : BASEENTITY ACCESS
#include "cbase.h"
#include "baseentity.h"
// HACK HACK HACK : BASEENTITY ACCESS

#include "interface.h"
#include "filesystem.h"
#include "engine/iserverplugin.h"
#include "dlls/iplayerinfo.h"
#include "eiface.h"
#include "igameevents.h"

#include "usercmd.h"
#include "bitbuf.h"
#include "in_buttons.h"

#include "ubbot_util.h"

// RANDOM_INT (MAX) & RANDOM_INT (MIN, MAX)
// RANDOM_FLOAT (MAX) & RANDOM_FLOAT (MIN, MAX)
// RANDOM_LONG (MAX) & RANDOM_LONG(MIN, MAX)


// FUNCTION TYPES (DOUBLE INPUT)

int RANDOM_INT(int min, int max)
{
    // Explenation why it is done like this: 
    // (random nr of (max-min)) + min
    // 
    // since i do not want to do 'ifs' (that will make it not 100% reliable)
    // due the following example:
    //
    // MIN = 100
    // MAX = 200
    // (rnd max) returns 50% chance of < 100. Making it already 50% chance
    // that MIN will return, and only 50% chance that something REALLY between
    // the given boundries will be returned.
    //
    // so, this method:
    // MIN = 100
    // MAX = 200
    // will make it
    // RND (MAX-MIN) -> RND(100) , returns ANYTHING random in this scope
    // and later adds MIN to it, so it can never go below MIN.
    //
    //
    
    // when invalid max
    if (max < min) return min;  
    
    // return value
    return ((rand() % (max-min)) + min);
}


// Give a random floating point (not really though)
float RANDOM_FLOAT(int min, int max)
{    
    // when invalid max
    if (max < min) return min;  
    
    // return value
    return (float)((rand() % (max-min)) + min);
}

// Give a random long
long RANDOM_LONG(int min, int max)
{
    return RANDOM_INT(min, max);
}


// FUNCTION TYPES (SINGLE INPUT)

// Give a random number
int RANDOM_INT(int max)
{
  if (max < 1) return 0;
  return (rand() % max);
}

// Give a random floating point (not really though)
float RANDOM_FLOAT(int max)
{
  if (max < 1) return 0;
  return (float)(rand() % max);
}

// Give a random long
long RANDOM_LONG(int max)
{
    return RANDOM_INT(max);
}


//-----------------------------------------------------------------------------
// Forward direction vector -> Euler angles
//-----------------------------------------------------------------------------
// COPIED FROM MATHLIB.CPP - STEFAN
void UTIL_VectorAngles( const Vector& forward, QAngle &angles )
{
//	Assert( s_bMathlibInitialized );
	float	tmp, yaw, pitch;
	
	if (forward[1] == 0 && forward[0] == 0)
	{
		yaw = 0;
		if (forward[2] > 0)
			pitch = 270;
		else
			pitch = 90;
	}
	else
	{
		yaw = (atan2(forward[1], forward[0]) * 180 / M_PI);
		if (yaw < 0)
			yaw += 360;

        // STEFAN: use normal sqrt
		tmp = sqrt (forward[0]*forward[0] + forward[1]*forward[1]);
		pitch = (atan2(-forward[2], tmp) * 180 / M_PI);
		if (pitch < 0)
			pitch += 360;
	}
	
	angles[0] = pitch;
	angles[1] = yaw;
	angles[2] = 0;
}

// This function is taken from the RealBot code, which was
// derived/from botmans hpb_bot code mostly.
int UTIL_InFieldOfView (edict_t * pEntity, Vector dest, Vector vViewAngle)
{
    // Updated to work with HL2

    // NOTE: Copy from Botman's BotInFieldOfView() routine.
    
    // find angles from source to destination...
    QAngle entity_angles;
    UTIL_VectorAngles (dest, entity_angles);

  // make yaw angle 0 to 360 degrees if negative...
    if (entity_angles.y < 0)
        entity_angles.y += 360;
    
    // get bot's current view angle...
    float view_angle = vViewAngle.y;

    // make view angle 0 to 360 degrees if negative...
    if (view_angle < 0)
        view_angle += 360;

    // return the absolute value of angle to destination entity
    // zero degrees means straight ahead,  45 degrees to the left or
    // 45 degrees to the right is the limit of the normal view angle

    // rsm - START angle bug fix
    int angle = abs ((int) view_angle - (int) entity_angles.y);

    if (angle > 180)
        angle = 360 - angle;

    return angle;
    // rsm - END
} 

// Thanks to cheeseh for this function!
// PURPOSE: Gets entities origin (center)
Vector UTIL_GetEntityOrigin ( edict_t *pEntity )
{
   //static float *fOrigin;
    
   //fOrigin = pEntity->GetIServerEntity()->GetNetworkable()->GetPVSInfo()->m_vCenter; 

   //return Vector(fOrigin[0],fOrigin[1],fOrigin[2]);
    return Vector(0,0,0);
} 


float UTIL_DistanceBetween( Vector v1, Vector v2 )
{
    return v1.DistTo(v2);    // distance between v1 and v2
}
